#include <stdio.h>
#include <string.h>
#include <stdbool.h>

int main(int argc, char *argv[]) {
  bool newline = true; // Enables newline in the end (to disable use arg -n)
  bool escapes = false; // Enables backslash-escaped characters (to enable use arg -e)
  for (int i = 1; i < argc; i++) {
    if (!strcmp(argv[i], "-n")) {
      newline = false;
    } else if (!strcmp(argv[i], "-e")) {
      escapes = true;
    } else if (!strcmp(argv[i], "-E")) {
      escapes = false;
    } else {
      if (escapes) {
	for (size_t j = 0; j < strlen(argv[i]); j++) {
	  if (argv[i][j] == '\\') {
	    j++;
	    switch(argv[i][j]) {
	    case 'b':
	      printf("\b");
	      break;
   	    case 'c':
	      return 0;
	    case 'e':
	      printf("\e");
	      break;
	    case 'f':
	      printf("\f");
	      break;
    	    case 'n':
	      printf("\n");
	      break;
    	    case 'r':
	      printf("\r");
	      break;
    	    case 't':
	      printf("\t");
	      break;
	    case 'v':
	      printf("\v");
	      break;
	    case '\\':
	      printf("\\");
	      break;
	    default:
	      printf("\\%c", argv[i][j]);
	    }
	  } else {
	    printf("%c", argv[i][j]);
	  }
	}
      } else {
	printf("%s", argv[i]);
      }
      if (i < argc - 1)
	printf(" ");
    }
  }
  if (newline) {
    printf("\n");
  }
  return 0;
}
